<html>

<head>
  <title>Mandelkeks</title>
  <meta charset="utf-8">
  <script src="lib.js"></script>
  <script src="gui.js"></script>
  <script src="mandel.js"></script>
  <script>

    var I, O, fW;
    var body, marginTop, marginRight, marginBottom, marginLeft;
    var canvas, canvas_id, context, dataset, row, col, N, M, m, Cr, Ci, ins;
    var gradient, mandelcor, sqmodlim, Z0r, Z0i, W, H, I, S, O, L, R;
    var plano, eixos, ctx_plano, ctx_eixos, passo;
    var centro = [];

    window.onload = function()
    {

       I = getParameterByName('I'    ) || 10000;
       O = getParameterByName('O',',') || [-0.7450206180950283,0.12440120606266036];
      fW = getParameterByName('fW'   ) || 0.00001267829811506426;

      if (
           ! getParameterByName('I'    ) ||
           ! getParameterByName('O',',') ||
           ! getParameterByName('fW'   )
         )
         location = '#I='+I + ';O='+O + ';fW='+fW;

      plano     = document.getElementById('plano');
      ctx_plano = plano.getContext('2d');
      eixos     = document.getElementById('eixos');
      ctx_eixos = eixos.getContext('2d');

      centro['x'] = 0;
      centro['y'] = 0;

      eixos.onmousemove = function(e) { pos = position(e); draw_eixos() };

   // passo = 2*Math.sqrt(lim_mod2) / ( ( plano.height > plano.width ? plano.width : plano.height ) - 2*5 );
      passo = 1;

      mandelcor = [0, 0, 0];
       sqmodlim = 4;
            Z0r = 0;
            Z0i = 0;

      canvas_id    = 'plano';

      body         = document.getElementsByTagName('body')[0];
      marginTop    = computed('margin-top'   );
      marginRight  = computed('margin-right' );
      marginBottom = computed('margin-bottom');
      marginLeft   = computed('margin-left'  );

      W = window.innerWidth  - ( marginLeft + marginRight  );
      H = window.innerHeight - ( marginTop  + marginBottom );

    var fH = fW*H/W;
         L = [ O[0] - fW/2 , O[1] - fH/2 ];
         R = [ O[0] + fW/2 , O[1] + fH/2 ];
         S = (R[0]-L[0])/W;

      canvas        = document.getElementById(canvas_id);
      canvas.width  = W;
      canvas.height = H;
      context       =  canvas.getContext('2d');
      dataset       = context.getImageData(0, 0, W, H);

      // <http://colorzilla.com/gradient-editor>
      gradient = [
                   [ [ 127, 127, 127 ],    0 ],
                   [ [   0,  64,   0 ],   20 ],
                   [ [   0,   0,   0 ],   50 ],
                   [ [ 153,   0,   0 ], 1000 ],
                   [ [ 239, 182,  47 ], 3000 ],
                   [ [  39,  82,  47 ], 5000 ],
                   [ [   0,   0, 127 ], 8500 ],
                 ];

      row = 0;
      Ci  = R[1];

      delay = new time(0,0,0,0);
      delay.StartTiming();
      define_canvas();
      mainloop();

    }

  </script>
  <style>
    body   { margin: 0; background: black }
    canvas { margin: auto; display: block }
    #plano, #eixos { position: absolute; cursor: none }
  </style>
</head>
<body>
<canvas id="plano"></canvas>
<canvas id="eixos"></canvas>
</body>
</html>
